// Package v2 provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.8.2 DO NOT EDIT.
package v2

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
)

const (
	BearerScopes = "Bearer.Scopes"
)

// Defines values for AzureUploadOptionsHyperVGeneration.
const (
	AzureUploadOptionsHyperVGenerationV1 AzureUploadOptionsHyperVGeneration = "V1"

	AzureUploadOptionsHyperVGenerationV2 AzureUploadOptionsHyperVGeneration = "V2"
)

// Defines values for BlueprintCustomizationsPartitioningMode.
const (
	BlueprintCustomizationsPartitioningModeAutoLvm BlueprintCustomizationsPartitioningMode = "auto-lvm"

	BlueprintCustomizationsPartitioningModeLvm BlueprintCustomizationsPartitioningMode = "lvm"

	BlueprintCustomizationsPartitioningModeRaw BlueprintCustomizationsPartitioningMode = "raw"
)

// Defines values for ComposeStatusValue.
const (
	ComposeStatusValueFailure ComposeStatusValue = "failure"

	ComposeStatusValuePending ComposeStatusValue = "pending"

	ComposeStatusValueSuccess ComposeStatusValue = "success"
)

// Defines values for CustomizationsPartitioningMode.
const (
	CustomizationsPartitioningModeAutoLvm CustomizationsPartitioningMode = "auto-lvm"

	CustomizationsPartitioningModeLvm CustomizationsPartitioningMode = "lvm"

	CustomizationsPartitioningModeRaw CustomizationsPartitioningMode = "raw"
)

// Defines values for ImageSBOMPipelinePurpose.
const (
	ImageSBOMPipelinePurposeBuildroot ImageSBOMPipelinePurpose = "buildroot"

	ImageSBOMPipelinePurposeImage ImageSBOMPipelinePurpose = "image"
)

// Defines values for ImageSBOMSbomType.
const (
	ImageSBOMSbomTypeSpdx ImageSBOMSbomType = "spdx"
)

// Defines values for ImageStatusValue.
const (
	ImageStatusValueBuilding ImageStatusValue = "building"

	ImageStatusValueFailure ImageStatusValue = "failure"

	ImageStatusValuePending ImageStatusValue = "pending"

	ImageStatusValueRegistering ImageStatusValue = "registering"

	ImageStatusValueSuccess ImageStatusValue = "success"

	ImageStatusValueUploading ImageStatusValue = "uploading"
)

// Defines values for ImageTypes.
const (
	ImageTypesAws ImageTypes = "aws"

	ImageTypesAwsHaRhui ImageTypes = "aws-ha-rhui"

	ImageTypesAwsRhui ImageTypes = "aws-rhui"

	ImageTypesAwsSapRhui ImageTypes = "aws-sap-rhui"

	ImageTypesAzure ImageTypes = "azure"

	ImageTypesAzureEap7Rhui ImageTypes = "azure-eap7-rhui"

	ImageTypesAzureRhui ImageTypes = "azure-rhui"

	ImageTypesAzureSapRhui ImageTypes = "azure-sap-rhui"

	ImageTypesEdgeCommit ImageTypes = "edge-commit"

	ImageTypesEdgeContainer ImageTypes = "edge-container"

	ImageTypesEdgeInstaller ImageTypes = "edge-installer"

	ImageTypesGcp ImageTypes = "gcp"

	ImageTypesGcpRhui ImageTypes = "gcp-rhui"

	ImageTypesGuestImage ImageTypes = "guest-image"

	ImageTypesImageInstaller ImageTypes = "image-installer"

	ImageTypesIotBootableContainer ImageTypes = "iot-bootable-container"

	ImageTypesIotCommit ImageTypes = "iot-commit"

	ImageTypesIotContainer ImageTypes = "iot-container"

	ImageTypesIotInstaller ImageTypes = "iot-installer"

	ImageTypesIotRawImage ImageTypes = "iot-raw-image"

	ImageTypesIotSimplifiedInstaller ImageTypes = "iot-simplified-installer"

	ImageTypesLiveInstaller ImageTypes = "live-installer"

	ImageTypesMinimalRaw ImageTypes = "minimal-raw"

	ImageTypesOci ImageTypes = "oci"

	ImageTypesVsphere ImageTypes = "vsphere"

	ImageTypesVsphereOva ImageTypes = "vsphere-ova"

	ImageTypesWsl ImageTypes = "wsl"
)

// Defines values for UploadStatusValue.
const (
	UploadStatusValueFailure UploadStatusValue = "failure"

	UploadStatusValuePending UploadStatusValue = "pending"

	UploadStatusValueRunning UploadStatusValue = "running"

	UploadStatusValueSuccess UploadStatusValue = "success"
)

// Defines values for UploadTypes.
const (
	UploadTypesAws UploadTypes = "aws"

	UploadTypesAwsS3 UploadTypes = "aws.s3"

	UploadTypesAzure UploadTypes = "azure"

	UploadTypesContainer UploadTypes = "container"

	UploadTypesGcp UploadTypes = "gcp"

	UploadTypesLocal UploadTypes = "local"

	UploadTypesOciObjectstorage UploadTypes = "oci.objectstorage"

	UploadTypesPulpOstree UploadTypes = "pulp.ostree"
)

// AWSEC2CloneCompose defines model for AWSEC2CloneCompose.
type AWSEC2CloneCompose struct {
	Region            string    `json:"region"`
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// AWSEC2UploadOptions defines model for AWSEC2UploadOptions.
type AWSEC2UploadOptions struct {
	Region            string   `json:"region"`
	ShareWithAccounts []string `json:"share_with_accounts"`
	SnapshotName      *string  `json:"snapshot_name,omitempty"`
}

// AWSEC2UploadStatus defines model for AWSEC2UploadStatus.
type AWSEC2UploadStatus struct {
	Ami    string `json:"ami"`
	Region string `json:"region"`
}

// AWSS3UploadOptions defines model for AWSS3UploadOptions.
type AWSS3UploadOptions struct {
	// If set to false (the default value), a long, obfuscated URL
	// is returned. Its expiration might be sooner than for other upload
	// targets.
	//
	// If set to true, a shorter URL is returned and
	// its expiration is the same as for the other upload targets.
	Public *bool  `json:"public,omitempty"`
	Region string `json:"region"`
}

// AWSS3UploadStatus defines model for AWSS3UploadStatus.
type AWSS3UploadStatus struct {
	Url string `json:"url"`
}

// AzureUploadOptions defines model for AzureUploadOptions.
type AzureUploadOptions struct {
	// Choose the VM Image HyperV generation, different features on Azure are available
	// depending on the HyperV generation.
	HyperVGeneration *AzureUploadOptionsHyperVGeneration `json:"hyper_v_generation,omitempty"`

	// Name of the uploaded image. It must be unique in the given resource group.
	// If name is omitted from the request, a random one based on a UUID is
	// generated.
	ImageName *string `json:"image_name,omitempty"`

	// Location of the provided resource_group, where the image should be uploaded and registered.
	// How to list all locations:
	// https://docs.microsoft.com/en-us/cli/azure/account?view=azure-cli-latest#az_account_list_locations'
	// If the location is not specified, it is deducted from the provided resource_group.
	Location *string `json:"location,omitempty"`

	// Name of the resource group where the image should be uploaded.
	ResourceGroup string `json:"resource_group"`

	// ID of subscription where the image should be uploaded.
	SubscriptionId string `json:"subscription_id"`

	// ID of the tenant where the image should be uploaded.
	// How to find it in the Azure Portal:
	// https://docs.microsoft.com/en-us/azure/active-directory/fundamentals/active-directory-how-to-find-tenant
	TenantId string `json:"tenant_id"`
}

// Choose the VM Image HyperV generation, different features on Azure are available
// depending on the HyperV generation.
type AzureUploadOptionsHyperVGeneration string

// AzureUploadStatus defines model for AzureUploadStatus.
type AzureUploadStatus struct {
	ImageName string `json:"image_name"`
}

// Blueprint defines model for Blueprint.
type Blueprint struct {
	// Architecture to use for the compose. If left empty the host arch
	// will be used.
	Architecture *string `json:"architecture,omitempty"`

	// Container images to embed into the final artfact
	Containers     *[]Container             `json:"containers,omitempty"`
	Customizations *BlueprintCustomizations `json:"customizations,omitempty"`
	Description    *string                  `json:"description,omitempty"`

	// The distribution to use for the compose. If left empty the host
	// distro will be used.
	Distro *string `json:"distro,omitempty"`

	// Package groups to be installed
	Groups *[]PackageGroup `json:"groups,omitempty"`

	// An alias for packages, retained for backwards compatability
	Modules *[]Package `json:"modules,omitempty"`
	Name    string     `json:"name"`

	// Packages to be installed
	Packages *[]Package `json:"packages,omitempty"`

	// A semver version number
	Version *string `json:"version,omitempty"`
}

// BlueprintCustomizations defines model for BlueprintCustomizations.
type BlueprintCustomizations struct {
	// Directories to create in the final artifact
	Directories *[]Directory `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo *FDO `json:"fdo,omitempty"`

	// Files to create in the final artifact
	Files *[]BlueprintFile `json:"files,omitempty"`

	// List of filesystem mountpoints to create
	Filesystem *[]BlueprintFilesystem `json:"filesystem,omitempty"`

	// Enable FIPS mode
	Fips *bool `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *BlueprintFirewall `json:"firewall,omitempty"`

	// List of groups to create
	Group *[]Group `json:"group,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale            `json:"locale,omitempty"`
	Openscap *BlueprintOpenSCAP `json:"openscap,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *BlueprintCustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Repositories to write to /etc/yum.repos.d/ in the final image. Note
	// that these are not used at build time.
	Repositories *[]BlueprintRepository `json:"repositories,omitempty"`
	Rhsm         *RHSMCustomization     `json:"rhsm,omitempty"`
	Rpm          *RPMCustomization      `json:"rpm,omitempty"`
	Services     *Services              `json:"services,omitempty"`

	// List of ssh keys
	Sshkey *[]SSHKey `json:"sshkey,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`

	// List of users to create
	User *[]BlueprintUser `json:"user,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type BlueprintCustomizationsPartitioningMode string

// A custom file to create in the final artifact.
type BlueprintFile struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// BlueprintFilesystem defines model for BlueprintFilesystem.
type BlueprintFilesystem struct {
	// size of the filesystem in bytes
	Minsize    uint64 `json:"minsize"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type BlueprintFirewall struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
	Zones    *[]FirewallZones  `json:"zones,omitempty"`
}

// BlueprintOpenSCAP defines model for BlueprintOpenSCAP.
type BlueprintOpenSCAP struct {
	Datastream    *string                `json:"datastream,omitempty"`
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// BlueprintRepository defines model for BlueprintRepository.
type BlueprintRepository struct {
	Baseurls   *[]string `json:"baseurls,omitempty"`
	Enabled    *bool     `json:"enabled,omitempty"`
	Filename   *string   `json:"filename,omitempty"`
	Gpgcheck   *bool     `json:"gpgcheck,omitempty"`
	Gpgkeys    *[]string `json:"gpgkeys,omitempty"`
	Id         string    `json:"id"`
	Metalink   *string   `json:"metalink,omitempty"`
	Mirrorlist *string   `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool   `json:"module_hotfixes,omitempty"`
	Name           *string `json:"name,omitempty"`
	Priority       *int    `json:"priority,omitempty"`
	RepoGpgcheck   *bool   `json:"repo_gpgcheck,omitempty"`
	Sslverify      *bool   `json:"sslverify,omitempty"`
}

// BlueprintUser defines model for BlueprintUser.
type BlueprintUser struct {
	Description *string `json:"description,omitempty"`

	// Group id to use instead of the default
	Gid *int `json:"gid,omitempty"`

	// A list of additional groups to add the user to
	Groups *[]string `json:"groups,omitempty"`

	// The user's home directory
	Home *string `json:"home,omitempty"`

	// ssh public key
	Key  *string `json:"key,omitempty"`
	Name string  `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`

	// Login shell to use
	Shell *string `json:"shell,omitempty"`

	// User id to use instead of the default
	Uid *int `json:"uid,omitempty"`
}

// CloneComposeBody defines model for CloneComposeBody.
type CloneComposeBody interface{}

// CloneComposeResponse defines model for CloneComposeResponse.
type CloneComposeResponse struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// CloneStatus defines model for CloneStatus.
type CloneStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded struct due to allOf(#/components/schemas/UploadStatus)
	UploadStatus `yaml:",inline"`
}

// ComposeId defines model for ComposeId.
type ComposeId struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// ComposeLogs defines model for ComposeLogs.
type ComposeLogs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageBuilds []interface{} `json:"image_builds"`
	Koji        *KojiLogs     `json:"koji,omitempty"`
}

// ComposeManifests defines model for ComposeManifests.
type ComposeManifests struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Manifests []interface{} `json:"manifests"`
}

// ComposeMetadata defines model for ComposeMetadata.
type ComposeMetadata struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// ID (hash) of the built commit
	OstreeCommit *string `json:"ostree_commit,omitempty"`

	// Package list including NEVRA
	Packages *[]PackageMetadata `json:"packages,omitempty"`
}

// ComposeRequest defines model for ComposeRequest.
type ComposeRequest struct {
	Blueprint      *Blueprint      `json:"blueprint,omitempty"`
	Customizations *Customizations `json:"customizations,omitempty"`
	Distribution   string          `json:"distribution"`
	ImageRequest   *ImageRequest   `json:"image_request,omitempty"`
	ImageRequests  *[]ImageRequest `json:"image_requests,omitempty"`
	Koji           *Koji           `json:"koji,omitempty"`
}

// ComposeSBOMs defines model for ComposeSBOMs.
type ComposeSBOMs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// The SBOM documents for each image built in the compose.
	Items [][]ImageSBOM `json:"items"`
}

// ComposeStatus defines model for ComposeStatus.
type ComposeStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageStatus   ImageStatus        `json:"image_status"`
	ImageStatuses *[]ImageStatus     `json:"image_statuses,omitempty"`
	KojiStatus    *KojiStatus        `json:"koji_status,omitempty"`
	Status        ComposeStatusValue `json:"status"`
}

// ComposeStatusError defines model for ComposeStatusError.
type ComposeStatusError struct {
	Details *interface{} `json:"details,omitempty"`
	Id      int          `json:"id"`
	Reason  string       `json:"reason"`
}

// ComposeStatusValue defines model for ComposeStatusValue.
type ComposeStatusValue string

// Container defines model for Container.
type Container struct {
	// Name to use for the container from the image
	Name *string `json:"name,omitempty"`

	// Reference to the container to embed
	Source string `json:"source"`

	// Control TLS verifification
	TlsVerify *bool `json:"tls_verify,omitempty"`
}

// ContainerUploadOptions defines model for ContainerUploadOptions.
type ContainerUploadOptions struct {
	// Name for the created container image
	Name *string `json:"name,omitempty"`

	// Tag for the created container image
	Tag *string `json:"tag,omitempty"`
}

// ContainerUploadStatus defines model for ContainerUploadStatus.
type ContainerUploadStatus struct {
	// Digest of the manifest of the uploaded container on the registry
	Digest string `json:"digest"`

	// FQDN of the uploaded image
	Url string `json:"url"`
}

// CustomRepository defines model for CustomRepository.
type CustomRepository struct {
	Baseurl        *[]string `json:"baseurl,omitempty"`
	CheckGpg       *bool     `json:"check_gpg,omitempty"`
	CheckRepoGpg   *bool     `json:"check_repo_gpg,omitempty"`
	Enabled        *bool     `json:"enabled,omitempty"`
	Filename       *string   `json:"filename,omitempty"`
	Gpgkey         *[]string `json:"gpgkey,omitempty"`
	Id             string    `json:"id"`
	Metalink       *string   `json:"metalink,omitempty"`
	Mirrorlist     *string   `json:"mirrorlist,omitempty"`
	ModuleHotfixes *bool     `json:"module_hotfixes,omitempty"`
	Name           *string   `json:"name,omitempty"`
	Priority       *int      `json:"priority,omitempty"`
	SslVerify      *bool     `json:"ssl_verify,omitempty"`
}

// Customizations defines model for Customizations.
type Customizations struct {
	Containers *[]Container `json:"containers,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will be used to depsolve and retrieve packages. Additionally,
	// these packages will be saved and imported to the `/etc/yum.repos.d/` directory
	// on the image
	CustomRepositories *[]CustomRepository `json:"custom_repositories,omitempty"`
	Directories        *[]Directory        `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo        *FDO          `json:"fdo,omitempty"`
	Files      *[]File       `json:"files,omitempty"`
	Filesystem *[]Filesystem `json:"filesystem,omitempty"`

	// System FIPS mode setup
	Fips *FIPS `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *FirewallCustomization `json:"firewall,omitempty"`

	// List of groups to create
	Groups *[]Group `json:"groups,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale   `json:"locale,omitempty"`
	Openscap *OpenSCAP `json:"openscap,omitempty"`
	Packages *[]string `json:"packages,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *CustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will only be used to depsolve and retrieve packages
	// for the OS itself (they will not be available for the build root or
	// any other part of the build process). The package_sets field for these
	// repositories is ignored.
	PayloadRepositories *[]Repository      `json:"payload_repositories,omitempty"`
	Rhsm                *RHSMCustomization `json:"rhsm,omitempty"`
	Rpm                 *RPMCustomization  `json:"rpm,omitempty"`
	Services            *Services          `json:"services,omitempty"`
	Subscription        *Subscription      `json:"subscription,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`
	Users    *[]User   `json:"users,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type CustomizationsPartitioningMode string

// DNFPluginConfig defines model for DNFPluginConfig.
type DNFPluginConfig struct {
	Enabled *bool `json:"enabled,omitempty"`
}

// A custom directory to create in the final artifact.
type Directory struct {
	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the directory as a group name or a gid
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the directory in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the directory
	Path string `json:"path"`

	// Owner of the directory as a user name or a uid
	User *interface{} `json:"user,omitempty"`
}

// Error defines model for Error.
type Error struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Code        string       `json:"code"`
	Details     *interface{} `json:"details,omitempty"`
	OperationId string       `json:"operation_id"`
	Reason      string       `json:"reason"`
}

// ErrorList defines model for ErrorList.
type ErrorList struct {
	// Embedded struct due to allOf(#/components/schemas/List)
	List `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Items []Error `json:"items"`
}

// FIDO device onboard configuration
type FDO struct {
	DiMfgStringTypeMacIface *string `json:"di_mfg_string_type_mac_iface,omitempty"`
	DiunPubKeyHash          *string `json:"diun_pub_key_hash,omitempty"`
	DiunPubKeyInsecure      *string `json:"diun_pub_key_insecure,omitempty"`
	DiunPubKeyRootCerts     *string `json:"diun_pub_key_root_certs,omitempty"`
	ManufacturingServerUrl  *string `json:"manufacturing_server_url,omitempty"`
}

// System FIPS mode setup
type FIPS struct {
	// Enables the system FIPS mode
	Enabled *bool `json:"enabled,omitempty"`
}

// A custom file to create in the final artifact.
type File struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// Filesystem defines model for Filesystem.
type Filesystem struct {
	// size of the filesystem in bytes
	MinSize    uint64 `json:"min_size"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type FirewallCustomization struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
}

// Firewalld services to enable or disable
type FirewallServices struct {
	// List of services to disable
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable
	Enabled *[]string `json:"enabled,omitempty"`
}

// Bind a list of network sources to a zone to restrict traffic from
// those sources based on the settings of the zone.
type FirewallZones struct {
	// name of the zone, if left empty the sources will apply to
	// the default zone.
	Name *string `json:"name,omitempty"`

	// List of sources for the zone
	Sources *[]string `json:"sources,omitempty"`
}

// GCPUploadOptions defines model for GCPUploadOptions.
type GCPUploadOptions struct {
	// Name of an existing STANDARD Storage class Bucket.
	Bucket *string `json:"bucket,omitempty"`

	// The name to use for the imported and shared Compute Engine image.
	// The image name must be unique within the GCP project, which is used
	// for the OS image upload and import. If not specified a random
	// 'composer-api-<uuid>' string is used as the image name.
	ImageName *string `json:"image_name,omitempty"`

	// The GCP region where the OS image will be imported to and shared from.
	// The value must be a valid GCP location. See https://cloud.google.com/storage/docs/locations.
	// If not specified, the multi-region location closest to the source
	// (source Storage Bucket location) is chosen automatically.
	Region string `json:"region"`

	// List of valid Google accounts to share the imported Compute Engine image with.
	// Each string must contain a specifier of the account type. Valid formats are:
	//   - 'user:{emailid}': An email address that represents a specific
	//     Google account. For example, 'alice@example.com'.
	//   - 'serviceAccount:{emailid}': An email address that represents a
	//     service account. For example, 'my-other-app@appspot.gserviceaccount.com'.
	//   - 'group:{emailid}': An email address that represents a Google group.
	//     For example, 'admins@example.com'.
	//   - 'domain:{domain}': The G Suite domain (primary) that represents all
	//     the users of that domain. For example, 'google.com' or 'example.com'.
	// If not specified, the imported Compute Engine image is not shared with any
	// account.
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// GCPUploadStatus defines model for GCPUploadStatus.
type GCPUploadStatus struct {
	ImageName string `json:"image_name"`
	ProjectId string `json:"project_id"`
}

// Group defines model for Group.
type Group struct {
	// Group id of the group to create (optional)
	Gid *int `json:"gid,omitempty"`

	// Name of the group to create
	Name string `json:"name"`
}

// Ignition configuration
type Ignition struct {
	Embedded  *IgnitionEmbedded  `json:"embedded,omitempty"`
	Firstboot *IgnitionFirstboot `json:"firstboot,omitempty"`
}

// IgnitionEmbedded defines model for IgnitionEmbedded.
type IgnitionEmbedded struct {
	Config string `json:"config"`
}

// IgnitionFirstboot defines model for IgnitionFirstboot.
type IgnitionFirstboot struct {
	// Provisioning URL
	Url string `json:"url"`
}

// ImageRequest defines model for ImageRequest.
type ImageRequest struct {
	Architecture string       `json:"architecture"`
	ImageType    ImageTypes   `json:"image_type"`
	Ostree       *OSTree      `json:"ostree,omitempty"`
	Repositories []Repository `json:"repositories"`

	// Size of image, in bytes. When set to 0 the image size is a minimum
	// defined by the image type.
	Size *uint64 `json:"size,omitempty"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions *UploadOptions `json:"upload_options,omitempty"`

	// The type and options for multiple upload targets. Each item defines
	// a separate upload destination with its own options. Multiple
	// different targets as well as multiple targets of the same kind are
	// supported.
	UploadTargets *[]UploadTarget `json:"upload_targets,omitempty"`
}

// ImageSBOM defines model for ImageSBOM.
type ImageSBOM struct {
	// The name of the osbuild pipeline which has the packages described
	// in the SBOM installed.
	PipelineName string `json:"pipeline_name"`

	// The purpose of the pipeline. The `buildroot` pipeline was used for
	// the build environment dueing the image build. The `image` pipeline
	// represents the actual content of the image. Due to the nature of
	// some image types, there may be multiple pipelines of the same
	// purpose.
	PipelinePurpose ImageSBOMPipelinePurpose `json:"pipeline_purpose"`

	// The SBOM document in the 'sbom_type' format.
	Sbom interface{} `json:"sbom"`

	// The type of the SBOM document. Currently only SPDX is supported.
	SbomType ImageSBOMSbomType `json:"sbom_type"`
}

// The purpose of the pipeline. The `buildroot` pipeline was used for
// the build environment dueing the image build. The `image` pipeline
// represents the actual content of the image. Due to the nature of
// some image types, there may be multiple pipelines of the same
// purpose.
type ImageSBOMPipelinePurpose string

// The type of the SBOM document. Currently only SPDX is supported.
type ImageSBOMSbomType string

// ImageStatus defines model for ImageStatus.
type ImageStatus struct {
	Error          *ComposeStatusError `json:"error,omitempty"`
	Status         ImageStatusValue    `json:"status"`
	UploadStatus   *UploadStatus       `json:"upload_status,omitempty"`
	UploadStatuses *[]UploadStatus     `json:"upload_statuses,omitempty"`
}

// ImageStatusValue defines model for ImageStatusValue.
type ImageStatusValue string

// ImageTypes defines model for ImageTypes.
type ImageTypes string

// ImportKeys defines model for ImportKeys.
type ImportKeys struct {
	Files *[]string `json:"files,omitempty"`
}

// Installer defines model for Installer.
type Installer struct {
	SudoNopasswd *[]string `json:"sudo-nopasswd,omitempty"`
	Unattended   *bool     `json:"unattended,omitempty"`
}

// Kernel defines model for Kernel.
type Kernel struct {
	// Appends arguments to the bootloader kernel command line
	Append *string `json:"append,omitempty"`

	// Name of the kernel to use
	Name *string `json:"name,omitempty"`
}

// Koji defines model for Koji.
type Koji struct {
	Name    string `json:"name"`
	Release string `json:"release"`
	Server  string `json:"server"`
	TaskId  int    `json:"task_id"`
	Version string `json:"version"`
}

// KojiLogs defines model for KojiLogs.
type KojiLogs struct {
	Import interface{} `json:"import"`
	Init   interface{} `json:"init"`
}

// KojiStatus defines model for KojiStatus.
type KojiStatus struct {
	BuildId *int `json:"build_id,omitempty"`
}

// List defines model for List.
type List struct {
	Kind  string `json:"kind"`
	Page  int    `json:"page"`
	Size  int    `json:"size"`
	Total int    `json:"total"`
}

// LocalUploadOptions defines model for LocalUploadOptions.
type LocalUploadOptions struct {
	// This is used in combination with the OSBUILD_LOCALSAVE environmental
	// variable on the server to enable saving the compose locally. This
	// is for development use only, and is not available to users.
	LocalSave bool `json:"local_save"`
}

// Locale configuration
type Locale struct {
	// Sets the keyboard layout
	Keyboard *string `json:"keyboard,omitempty"`

	// List of locales to be installed, the first one becomes primary, subsequent ones are secondary
	Languages *[]string `json:"languages,omitempty"`
}

// OCIUploadOptions defines model for OCIUploadOptions.
type OCIUploadOptions map[string]interface{}

// OCIUploadStatus defines model for OCIUploadStatus.
type OCIUploadStatus struct {
	Url string `json:"url"`
}

// OSTree defines model for OSTree.
type OSTree struct {
	// A URL which, if set, is used for fetching content. Implies that `url` is set as well,
	// which will be used for metadata only.
	Contenturl *string `json:"contenturl,omitempty"`

	// Can be either a commit (example: 02604b2da6e954bd34b8b82a835e5a77d2b60ffa), or a branch-like reference (example: rhel/8/x86_64/edge)
	Parent *string `json:"parent,omitempty"`
	Ref    *string `json:"ref,omitempty"`

	// Determines whether a valid subscription manager (candlepin) identity is required to
	// access this repository. Consumer certificates will be used as client certificates when
	// fetching metadata and content.
	Rhsm *bool   `json:"rhsm,omitempty"`
	Url  *string `json:"url,omitempty"`
}

// ObjectReference defines model for ObjectReference.
type ObjectReference struct {
	Href string `json:"href"`
	Id   string `json:"id"`
	Kind string `json:"kind"`
}

// OpenSCAP defines model for OpenSCAP.
type OpenSCAP struct {
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// OpenSCAPJSONTailoring defines model for OpenSCAPJSONTailoring.
type OpenSCAPJSONTailoring struct {
	Filepath  string `json:"filepath"`
	ProfileId string `json:"profile_id"`
}

// OpenSCAPTailoring defines model for OpenSCAPTailoring.
type OpenSCAPTailoring struct {
	Selected   *[]string `json:"selected,omitempty"`
	Unselected *[]string `json:"unselected,omitempty"`
}

// Package defines model for Package.
type Package struct {
	// Name of the package to install. File globbing is supported,
	// eg. 'openssh-*'
	Name string `json:"name"`

	// Optional version of the package to install. If left blank the
	// latest available version will be used. Wildcards are supported
	// eg. '4.11.*'
	Version *string `json:"version,omitempty"`
}

// PackageGroup defines model for PackageGroup.
type PackageGroup struct {
	// Package group name
	Name string `json:"name"`
}

// PackageMetadata defines model for PackageMetadata.
type PackageMetadata struct {
	Arch      string  `json:"arch"`
	Epoch     *string `json:"epoch,omitempty"`
	Name      string  `json:"name"`
	Release   string  `json:"release"`
	Sigmd5    string  `json:"sigmd5"`
	Signature *string `json:"signature,omitempty"`
	Type      string  `json:"type"`
	Version   string  `json:"version"`
}

// PulpOSTreeUploadOptions defines model for PulpOSTreeUploadOptions.
type PulpOSTreeUploadOptions struct {
	// Basepath for distributing the repository
	Basepath string `json:"basepath"`

	// Repository to import the ostree commit to
	Repository    *string `json:"repository,omitempty"`
	ServerAddress *string `json:"server_address,omitempty"`
}

// PulpOSTreeUploadStatus defines model for PulpOSTreeUploadStatus.
type PulpOSTreeUploadStatus struct {
	RepoUrl string `json:"repo_url"`
}

// RHSMConfig defines model for RHSMConfig.
type RHSMConfig struct {
	DnfPlugins          *SubManDNFPluginsConfig `json:"dnf_plugins,omitempty"`
	SubscriptionManager *SubManConfig           `json:"subscription_manager,omitempty"`
}

// RHSMCustomization defines model for RHSMCustomization.
type RHSMCustomization struct {
	Config *RHSMConfig `json:"config,omitempty"`
}

// RPMCustomization defines model for RPMCustomization.
type RPMCustomization struct {
	ImportKeys *ImportKeys `json:"import_keys,omitempty"`
}

// Repository configuration.
// At least one of the 'baseurl', 'mirrorlist', 'metalink' properties must
// be specified. If more of them are specified, the order of precedence is
// the same as listed above.
type Repository struct {
	Baseurl  *string `json:"baseurl,omitempty"`
	CheckGpg *bool   `json:"check_gpg,omitempty"`

	// Enables gpg verification of the repository metadata
	CheckRepoGpg *bool `json:"check_repo_gpg,omitempty"`

	// GPG key used to sign packages in this repository.
	Gpgkey     *string `json:"gpgkey,omitempty"`
	IgnoreSsl  *bool   `json:"ignore_ssl,omitempty"`
	Metalink   *string `json:"metalink,omitempty"`
	Mirrorlist *string `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool `json:"module_hotfixes,omitempty"`

	// Naming package sets for a repository assigns it to a specific part
	// (pipeline) of the build process.
	PackageSets *[]string `json:"package_sets,omitempty"`

	// Determines whether a valid subscription is required to access this repository.
	Rhsm *bool `json:"rhsm,omitempty"`
}

// SSHKey defines model for SSHKey.
type SSHKey struct {
	// Adds the key to the user's authorized_keys file
	Key string `json:"key"`

	// User to configure the ssh key for
	User string `json:"user"`
}

// Services defines model for Services.
type Services struct {
	// List of services to disable by default
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable by default
	Enabled *[]string `json:"enabled,omitempty"`

	// List of services to mask by default
	Masked *[]string `json:"masked,omitempty"`
}

// SubManConfig defines model for SubManConfig.
type SubManConfig struct {
	Rhsm      *SubManRHSMConfig      `json:"rhsm,omitempty"`
	Rhsmcertd *SubManRHSMCertdConfig `json:"rhsmcertd,omitempty"`
}

// SubManDNFPluginsConfig defines model for SubManDNFPluginsConfig.
type SubManDNFPluginsConfig struct {
	ProductId           *DNFPluginConfig `json:"product_id,omitempty"`
	SubscriptionManager *DNFPluginConfig `json:"subscription_manager,omitempty"`
}

// SubManRHSMCertdConfig defines model for SubManRHSMCertdConfig.
type SubManRHSMCertdConfig struct {
	AutoRegistration *bool `json:"auto_registration,omitempty"`
}

// SubManRHSMConfig defines model for SubManRHSMConfig.
type SubManRHSMConfig struct {
	ManageRepos *bool `json:"manage_repos,omitempty"`
}

// Subscription defines model for Subscription.
type Subscription struct {
	ActivationKey string `json:"activation_key"`
	BaseUrl       string `json:"base_url"`
	Insights      bool   `json:"insights"`
	Organization  string `json:"organization"`

	// Optional flag to use rhc to register the system, which also always enables Insights.
	Rhc       *bool  `json:"rhc,omitempty"`
	ServerUrl string `json:"server_url"`
}

// Timezone configuration
type Timezone struct {
	// List of ntp servers
	Ntpservers *[]string `json:"ntpservers,omitempty"`

	// Name of the timezone, defaults to UTC
	Timezone *string `json:"timezone,omitempty"`
}

// Options for a given upload destination.
// This should really be oneOf but AWSS3UploadOptions is a subset of
// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
// are also valid AWSS3UploadOptionas objects which violates the oneOf
// rules. Therefore, we have to use anyOf here but be aware that it isn't
// possible to mix and match more schemas together.
type UploadOptions interface{}

// UploadStatus defines model for UploadStatus.
type UploadStatus struct {
	Options interface{}       `json:"options"`
	Status  UploadStatusValue `json:"status"`
	Type    UploadTypes       `json:"type"`
}

// UploadStatusValue defines model for UploadStatusValue.
type UploadStatusValue string

// UploadTarget defines model for UploadTarget.
type UploadTarget struct {
	Type UploadTypes `json:"type"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions UploadOptions `json:"upload_options"`
}

// UploadTypes defines model for UploadTypes.
type UploadTypes string

// User defines model for User.
type User struct {
	Groups *[]string `json:"groups,omitempty"`
	Key    *string   `json:"key,omitempty"`
	Name   string    `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`
}

// Page defines model for page.
type Page string

// Size defines model for size.
type Size string

// PostComposeJSONBody defines parameters for PostCompose.
type PostComposeJSONBody ComposeRequest

// PostCloneComposeJSONBody defines parameters for PostCloneCompose.
type PostCloneComposeJSONBody CloneComposeBody

// GetErrorListParams defines parameters for GetErrorList.
type GetErrorListParams struct {
	// Page index
	Page *Page `json:"page,omitempty"`

	// Number of items in each page
	Size *Size `json:"size,omitempty"`
}

// PostComposeJSONRequestBody defines body for PostCompose for application/json ContentType.
type PostComposeJSONRequestBody PostComposeJSONBody

// PostCloneComposeJSONRequestBody defines body for PostCloneCompose for application/json ContentType.
type PostCloneComposeJSONRequestBody PostCloneComposeJSONBody

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// The status of a cloned compose
	// (GET /clones/{id})
	GetCloneStatus(ctx echo.Context, id string) error
	// Create compose
	// (POST /compose)
	PostCompose(ctx echo.Context) error
	// The status of a compose
	// (GET /composes/{id})
	GetComposeStatus(ctx echo.Context, id string) error
	// Clone an existing compose
	// (POST /composes/{id}/clone)
	PostCloneCompose(ctx echo.Context, id string) error
	// Get logs for a compose.
	// (GET /composes/{id}/logs)
	GetComposeLogs(ctx echo.Context, id string) error
	// Get the manifests for a compose.
	// (GET /composes/{id}/manifests)
	GetComposeManifests(ctx echo.Context, id string) error
	// Get the metadata for a compose.
	// (GET /composes/{id}/metadata)
	GetComposeMetadata(ctx echo.Context, id string) error
	// Get the SBOMs for a compose.
	// (GET /composes/{id}/sboms)
	GetComposeSBOMs(ctx echo.Context, id string) error
	// Get a list of all possible errors
	// (GET /errors)
	GetErrorList(ctx echo.Context, params GetErrorListParams) error
	// Get error description
	// (GET /errors/{id})
	GetError(ctx echo.Context, id string) error
	// Get the openapi spec in json format
	// (GET /openapi)
	GetOpenapi(ctx echo.Context) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// GetCloneStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetCloneStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetCloneStatus(ctx, id)
	return err
}

// PostCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCompose(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCompose(ctx)
	return err
}

// GetComposeStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeStatus(ctx, id)
	return err
}

// PostCloneCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCloneCompose(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCloneCompose(ctx, id)
	return err
}

// GetComposeLogs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeLogs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeLogs(ctx, id)
	return err
}

// GetComposeManifests converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeManifests(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeManifests(ctx, id)
	return err
}

// GetComposeMetadata converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeMetadata(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeMetadata(ctx, id)
	return err
}

// GetComposeSBOMs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeSBOMs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeSBOMs(ctx, id)
	return err
}

// GetErrorList converts echo context to params.
func (w *ServerInterfaceWrapper) GetErrorList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Parameter object where we will unmarshal all parameters from the context
	var params GetErrorListParams
	// ------------- Optional query parameter "page" -------------

	err = runtime.BindQueryParameter("form", true, false, "page", ctx.QueryParams(), &params.Page)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter page: %s", err))
	}

	// ------------- Optional query parameter "size" -------------

	err = runtime.BindQueryParameter("form", true, false, "size", ctx.QueryParams(), &params.Size)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter size: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetErrorList(ctx, params)
	return err
}

// GetError converts echo context to params.
func (w *ServerInterfaceWrapper) GetError(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetError(ctx, id)
	return err
}

// GetOpenapi converts echo context to params.
func (w *ServerInterfaceWrapper) GetOpenapi(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetOpenapi(ctx)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/clones/:id", wrapper.GetCloneStatus)
	router.POST(baseURL+"/compose", wrapper.PostCompose)
	router.GET(baseURL+"/composes/:id", wrapper.GetComposeStatus)
	router.POST(baseURL+"/composes/:id/clone", wrapper.PostCloneCompose)
	router.GET(baseURL+"/composes/:id/logs", wrapper.GetComposeLogs)
	router.GET(baseURL+"/composes/:id/manifests", wrapper.GetComposeManifests)
	router.GET(baseURL+"/composes/:id/metadata", wrapper.GetComposeMetadata)
	router.GET(baseURL+"/composes/:id/sboms", wrapper.GetComposeSBOMs)
	router.GET(baseURL+"/errors", wrapper.GetErrorList)
	router.GET(baseURL+"/errors/:id", wrapper.GetError)
	router.GET(baseURL+"/openapi", wrapper.GetOpenapi)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+x9CXPjOK7wX2H5TVXPfO37SJyumtrnOJdzJ87RyborS0u0xFgiFZKy48zr//4VD8mS",
	"LV+dzO7Obr+qt9OxSBAEQRAAAfCPnEX9gBJEBM99+SMXQAZ9JBAzfzlI/tdG3GI4EJiS3JfcJXQQwMRG",
	"r7l8Dr1CP/BQqvkIeiHKfclVct+/53NY9nkJEZvk8jkCfflFtcznuOUiH8ouYhLI37lgmDiqG8dvGWOf",
	"h34fMUAHAAvkc4AJQNBygQGYxCYCEGNTLi/ER7Vdhs/36KMC3brv7rerbY8S1Jbk42ogaNtYogm9S0YD",
	"xASWiAygx1E+FyR++iPHkKPmMzdQPsddyNDTGAv3CVoWDc3CmJnlvvw9V6nW6o2t7eZOuVLNfcvnFCUy",
	"YZkfIGNwoubO0EuIGbIlGIPDt7gZ7T8jS8h+en63gUehfaFIz394gjHiORQWxoiLQiWX/2dOO5/jBAbc",
	"peJJr3YSJ39SiL7OY5VNsGxcV5GxK6AI9S5JEQr6OI0R9HGhbDVr5e2d2vZ2o7HTsOv9LIptSOKZychx",
	"8yt4oFt7DwsEYd/Dlt7CAxh6Im6X3tKdAeBIAEGB+gx+FS4CpgtQm/e3PIDAo8TJA9ofhNyCAtng9vq0",
	"RzAHDImQEWQXQUdwgF4DzKAEDXzsuAL0EeCUEsSAcCEBA8oAFS5iIFRz6xEBmYMEL/ZIj0xxESxEclju",
	"UiYQk6OBxGAAErtHcHpAzIHEnUMfAcjVUPLv5HBgOtp0ifqUegiS9y/qesu5iBVD5mWL4uQQslEm/LeQ",
	"ofewizsJEHsaPTmIIE3PFOvk7uT005zTdinlSNH47gx0fHkuHUkwd2AKJQ9sPBgghogAAwRFyBAHlACF",
	"MIDy/0cQe7DvoR6xUYCIjYkjW0i4c+D0wiES+pIaCqm7aoIi0/2JJT6xyJk5xiSL0IEaQjMGsoHqILkY",
	"+CFXjBsS/BLKs1Y1dPAIEcAQpyGzEHAYDYOi4lk5iOQ+6mMht8aAUV91kSuHuJCMzCCxqQ8oQaAPObLl",
	"DCG4ve3sAcx7xMwQ2WaCSQmpEMsSQR61EiuVnOCp+RJNMmB0hOUkI/SfFPp5MHYR00uoRpH7LfRsNfmI",
	"LpDIbg7mAjGF3xEdyy3qYS4A9DwQocG/9IgrRMC/lEo2tXjRxxajnA5E0aJ+CZFCyEuWh0tQrn3JyO6/",
	"jTAa/65+KlgeLnhQIC7+B75Fwv1JDvQUD/JJkVxiHP0kSU+oADxAFh5gZOcBFvJHG9mhlVqQBXSYJbrc",
	"7yiU+yNb8if7LueuNLusQe5ZVG5oaEFybcAcqhGzzu+wH6PwhO15pDp7EqVksx9Apo4adrNftQqwX60X",
	"6vVKrbBTthqFrUq1Vt5CzfIOqmZhJxCBRCzBSyKhG62HlWHBASa2Wmu9Q7VMuaRMQG8dXoz4UOARKtiY",
	"IUtQNikNQmJDHxEBPT73teDScUHQghy6oFGeIVLD2kaDRn+rULFqg0LdhuUC3KpWC+V+eatcre3Y2/b2",
	"yqNkSrH5tZ3jwBUHwqIDJy0h1xE5M0gmAGShsOuFKGCYiA2PIsgsFwtkybNinmFaia+SB0KO4qPe0tZA",
	"EXQGwEMDAZAfiIn65FIprZjl9sgYe57iJz7P4a/NraetehYPW5QIiIkxzWZOwuib5lku8UJ+Xx4qRCoz",
	"LpKsCj0AmRhAS+q6sfr8C0OD3Jfc/5SmlmDJ2DqlGG6WWm2FXFAfv8H4uF8GKl6Mdrrb95lTPUOftzEX",
	"jM7P+kYqivIb7odKoGy2Gj2iAYNl6zFANmWwUNvJWhLF/TzLQraGUnTo7xKtvjzFuYCeh+x1iW+gaJGb",
	"QX+f2qGxdWc4lADoYaOBBhoKz0vdVa6lrX7uQ2s4hszmikpQwD72sJio2W+CXRZi0Y6eo1eEy0KKvZdW",
	"WdiMEOOZOkoLcOSPEAOmBSDKuZBa/u3idnG7vFIQrRZB7bnNsoFAioQ/ziLd3vSjpJ7FEBSxzhjverzJ",
	"to9ATrLoObDpqv4HexeqJc5kzwP580ehGhNYQs1EV4424QL5GVqq1CDpAEzbAF9qfAHFRCRQ/CFkzKCZ",
	"KGUJjX0ibRBw0LnsAp/aKNM+HGCGxtDzNsDEdIjE1WIqTKXVZrNeKKCkkM22f9qUDLCjTLFIGquGWWaU",
	"Q3B0MizDohO1Uy4+JT7UXnuy0QhbK2ywZAegO+SBFTJpNXoTQIk3kafDIPTiwwXZDipw7AeeUvkLkchi",
	"QE5h5hQp2WhU4jbMnGDUceUM44bf87khYgStZIMT3cqYah5a1f5Ut/qez9EAEW7BYG1GuwgQ6bZbl1rO",
	"M6EWAxPnSfFyypSHoaAFb+TPGfRd5CFLAFcq1/psHxolPDqiY8jILoJPEaBP+rs8+xkcg5B4iPMeEUqT",
	"lya+tHopAz5lKLXDsTRCsOUCC3IkFfkYzundWRF8UrChN4YT3iMhR1z+ngdIGuJjFynBZYYgFKBXwWAS",
	"fhF8YnD8CaieErMYfd4jWUAW4Jl2OjA4zuVzmn4xKb9l2okB5XjRuXGd+Co3/ZhhoRTaEhJWaRL6RdW/",
	"aJfSEtq4Kc6pQJLEUMhvPCKCUFoUgAL0Q+zZQGAfFdfXKmJ2irHLPIOYy/1VoK6PumepU1d1DFb3u5zv",
	"xhGTMmEl+t2onezD3SGaLBa3nLtgiCZ8XdJ0u0cnKJMaksZvlKzc3TdRu+/5XMi1wMnGTX59z/l3y7NM",
	"hu/LFCR1fmfoaNrKUEf0Kp1B89mM6gQFzLaXJOaR/FfQIQeBByVk9CoWqvvzwNT5NwsJAgfbci9D43kx",
	"59v0TGBU3TlQgi4GuS9/n1eX418wEciRBP2mtf6sOznEfMylFsuBBhAfVAojTAC1BFTHlw9FCpHyVj3T",
	"4AygcLM0deGC2Kb00nNSosOfmN/nIGYz3cWY6Cu9NP3CiH6y1weRb0ZtVzP8toorp9pjmrV8TLIvKeWv",
	"yfkY1RIT0J8IxJPTqFbq2/VmbavezOdeCw4tGFRCTMRWXVt50TGQdpKURpCttEsSnfMxvismPFUwl1oo",
	"szq97mYDy6h2WnbOXQpRJvhiuaM+g1+l2UqZAAwSB/HflAc4YFRQi3pKLEntJEnGv+eq1S/CCnL5XLNs",
	"/oF9GKh/bnZXuKakjyaclPhStmrH1jrCMoLwqHptJixjZWuOKaW844Ih6GdO95lT8iQg9qj6ZQWK0TDH",
	"3Yvzm7iTFA3Uw9Yk0596GQq5e2NfONBtQWcvEtryYAZSXvM84FKQQAEgmWglnFhSVYq9/UDQHpF867iC",
	"x1qg1Hp8KLAFPW8iOY4g5WY3YknOxMMSVDS4GdmihFPP6CNGEn7JhaHyac7LP0bl7jWznOecTamYoOCs",
	"HJqOtHRzJpSiuYXvQ45C5qX5byouIl+0ZZMiQ7YLtR/a0gdhycZclJiLvGapWdI+yJKESHmJ8lKKWgxn",
	"ethn9hFS1myScikr1kMLnURO4FgusobZXZ3AUUpTcpYrkVmwgj4S0MNkmE0pHzNGGS9qD2DAqFyOImVO",
	"Ker3N6kg/x55CKu9sFyubkFmub/HXtxVZNODeJiLeSRiHOTnooWIoFyN/zeGPAQ5+r1Z0Fs9MTKU/7tV",
	"178o/HYhRxfddXBR/sQnl4oBfs32NHG5qByolpBhMZHnm0AJfUPdkUdcuuiWe7GDkGEqwSY+xqe3tmee",
	"lrMH594IMTyYZH2evT1YsdtujbayiaNuhSfbyZKYWn/EduS+lnIQQTvSICK7OZ9BkUUO6Ja+HKUDMEU+",
	"4d+Btq2vnqVmJWhSvZ+yoGpeWWevuzTLx3NjBvjEgWwA4husLJCZlpK0kHQUiTSUUtof524B2dVGo7ID",
	"Wq1Wq107f4Ptive416mc3+w35G+dc3Z4ss/OHvDns7PbcXgEr1vH/vUp7bxdD6ove1V7r/FW3r15LW29",
	"ZuE0fzElp1PJVpU5H1OWdb1o7r9NA8AFZOokEy74ZeuXPPil8Ute6rm/VPu/xB6IPgJcUHn+Qd4jkABE",
	"LDYJ5BkXQSqCC+EiNsYJx0UfAaHsI1ur0FNzpkfifsk9mYy/Qlrpm73HdzAB6qNhz0y9Pout5fb5Ea5e",
	"17WeDL/bpbbin6k1sOxAzgjfU6ZV8pdrxANKTGCf560B9UJhdo1UrImFlAUyc99pp9mpUq2hemNru4Ca",
	"O/1CpWrXCrDe2CrUq1tbjUa9Xi6Xy6sVlXWkWjy76VXsj09qWfvUha8eVtOzY/8HUVJP6ZQ6/EMnpW6z",
	"ldssU78xKKQNRblt2ABa6I/vWaJ5SJ/xSicxfcZqLtnX6wahpaQ4gwQPEBcfSg8/CfT9xJg1jWPoy2eG",
	"BIx8SB81MSq1NvRkUd/HIjMi5VcXcve3SFbKFRDANM//wLWq1gYwsbxQBbed799dtza8Wo0JsYalmqDf",
	"tY5AW6lHESp03PB0hWbiC/K5fhzP8e37rObVT8Z6rOWj3DyEISNyIRF9kJZI0pYqNHML4wLZlC5L73xk",
	"44iGs53X9zXMgvlRMTG3i1IESCx7d/fi7GOFYzTNeSVTjgVsaoW+culKO0TlBOibI715YgeAjghJ8v5a",
	"AKfxl+b6Y386QshD5Ydwla4mgLTNBBBjqgDxvLrViYDoWxFERphRIuEr51aiRY9AS4TQA8Y0j68o1bjr",
	"blq14HL4zPuCZXJRg18qEz9Cicg6+ngMd/XUjIaRT3VFG+6IKZSsDbEmPnJfTAGt1ydFyDuVoDK7DgZQ",
	"eoLrrMs+Y5RlOAaRgFi5h2YdIikLG/JM03VeNYobzyGg5yOlobmw5KFlIS7nMoDYC5m0IUyctZxQwqqL",
	"G85JzWkk2tzMloRYzwWERWFycUDuwthmHeCYdW1q2HjqbYyARkF36XsK5ctkk6L5Sbnd1KhfBHQyzWuP",
	"P02dGPMXV4x64Oa0C1QbPMBW5GqPB1XJC6vcH2aCmaZVNKX3BPQvWZZ4PYyxaqXDF2eCJyhXQjOTVNDJ",
	"EOHQ2XAEHfKdaRCsok1CFm4Sz+WYs3/WwSZ/jyR+pKHOJQpMJ2OyFCIeyzbtTV7HzIXN1d55dgbCDG1e",
	"QjgpYlryJyYcvmTW48sSqs1mjOSjKWdym1Kr1vBt/5u4tpX78ckJnGwXpP4c+Sqz27zLO258ZT/d33+6",
	"+/vDPNece0/v9Uu/K4I0HTz+UbHfT8sjjPZVPFSyTSoiOXFHiAlIm2JFcOMijnok1TsZqC1PWxsFnHoj",
	"ZFKEBMNohGL4RdCKCeRN8ioejE8/Tz2tcGSyjLAfUJa4SPzHXCjUP6Zu7B4x0ncqNdej66y4yyDvTMDv",
	"vyRod81L7HWibtcGtTpmdimEzmV3kyDZ6AZ+Ltxr0bXKv1WkbDJf5mcA7V82gDYdNzt15CViWwLKhcMQ",
	"3yyS5WcQ7r9FEG4AJ1K7/pcclWrbrX1e9ki0NS+6AAuOvIFKxp9oYISqnOQ4W3rGpcUoFYCyHoFkYlLe",
	"JaGTPmwVxCUN/N8UztHATxwJDgYYeXYEc246mAPsEMqiBK21xO1/QAxxIvNyZb9k23dEBa9/+K8f5bt3",
	"fnDphQ4m+jibt/CWGESZ8GJdZ3HEcKyo/UjYMCI8ZOgpgCyqjLO8iMW+ag+icHigO4KEHgfQK05ay8mY",
	"pjXiiqez0cHFcUyxiTHG9r8kuHiK1tII4+1G48cijJNBI3NhxjZmPxhlPEPNOMLYBBx/BDHXDTWO3bUf",
	"5Uu3zBrOp9EmPcCyB0wk62ckj6znCrZ0qpppPgM4212tpnxqjP71pq1aL7kVWkteaVK/5wJE2kgbBkZ3",
	"9i6MQgwo6VPIVoVI2/jJHzhPmtxPEoknH1pPUlQtWFcckqcg7D8N0eTJhdxd3QoTjiyT3b68peT9JwuZ",
	"qO15pwkkoZShoUJWHnGIPS0sJDPH/Mpi24ygXR1MH6dJAo6EKkmx8EBZJbl1TKOq3DMDO5df6zT6C6Su",
	"/Inn2Ypbh59pM/89aTMrsmWe/mrpMk8L82WyXUc/c2Y2zJn5voS03QTUH6JqhJa6l9XJ9ZQBWwexZxy7",
	"PHFiZCZsJuBNoSToKZBHkNiMdqlzatWounF60IGQC0dEsGEpyIV0f4yymDYg+i4mNoBx0DlBYkzZEOgr",
	"Zh1yDqSNKf/FkMTKEkAwOBhgS93F94hwKUdxj7hEmTqWkRCYOPGRJyFlHZjZHlSScFPKnnmA58rBRMMq",
	"RwcMAm+iEo+SlQingy4IFViyRSPw0dmizO2FIUi9sFyuWbqP+jf6e0n/5kM+1L98+z/9y1mrrX/4Pxxw",
	"JL7oX9W/9e+rLzSzeOGwffmeq/9+aA2RWOwxhkRrD/K87d60zvda13ugKyiDDgKWBzkHuwpEcbYUnfmj",
	"YEbYsOzejYu0mTcTFxLf+0ihqap72qBN/SAUCOwTB5Mo/KpHbuK6YArQTKW+MRau0e8O25fA3JrmjX8T",
	"c+WJS/vZdAiZLg45vYNSNYtSNeXiEn498smEsbECDHBBL3kYYluv+KdIkzHDSbVApLDepMTftCDlPCnl",
	"FPX3RNG0eE6Rtzh5qZagr9z1hp6qyGdMSij/xraCHlXYK4IuQiC+6PdoaBcdSh0TTsM166hCa6W4UJ+p",
	"jZguzKcCK0JP4ILBPC7iZ3mUIy4iJc3sP/KrqZ8XsadmzLjbb5LMlpRdJJ2WOEtkFG5Q9jZbjBi6qHmD",
	"qLnEV0FJc3IW+yr2LPaIil00TKKobm6HE2mbsWJphlF3MkVwpzDQyjAHkKEvPQJAAXySyuaXP5APsYft",
	"75++gBYB6i8AbZshzrUpwVDAEFfmSzyWJUGAmWkVwQFlwFAvDz5BD1vofxMhVJ+KZmRzPrZ0vw1x0EMb",
	"EIvG9icF5c8uwCD4XxgEPKCi6JhOUZ8kSspy2ZQaZv5ROUiJ1wwJbB8TnkkDm/oQky9/6P/KAdX2BN0Q",
	"CwT0r+DXgGEfsslv84N7nh4wygkzJy0Upu8sRaZb75NUqT7N4JS965azZlRCUwsHlR4FyaRHIvr2ZnRX",
	"xXBzXJGLldGIH9ZdvJyxU7/MkzmXzxkCJ3/8Uwpvx+fux5VMVGezhP80mzQDuYWIDYko9BnEdqFWrjUq",
	"tZVGUgJcflUFxsPI9N9AeVieI2nEknYOTJ0qv9JAg/8tM09ydRXeGYA/XvGtk7hu30CDjrqtsAVVfKmt",
	"7YV1LvP3o/Y6LIKLPqVi3c4HcYdMJXFujI1DksxV0CoHs2q3jNYHyZltgEJmZOQloyPM9b05uL0+XSvA",
	"MRO7ZNLF+yqQrlMfVG9F/fMase83k0DfMepspJVhCt0b2SqjqtQHXMVO/ULGJ1me8/oaH5GaZD72DRXB",
	"vYtIVLO9nKzaKztgebD6mGA/9HvERgNV/rI/SbRTek36cKlXd+o7W9vVna1FTiatrj/RYK20obQlNe1u",
	"SsFn69ZyTJ0aovspW0UproGHZovJm2wUgXygJ8l7BAKOAsikcDStbSQtLq3sqgMWCw7omERDFMGZgd8j",
	"05rpZgxpRYyRtI75FI3om5GhqvD9ULkCGOoRHgb6xN/gyl7T6kbBXXmQpnZJagPMcOm3aDeqjJi5QzXA",
	"AfIwWWk1mmma+GcQdTPWnWvsrDhmQ0PpS4PP2IQqsSiubVrMPKwjXIKQRQ+LzKNjPsbV1U0nHVbxD4Ue",
	"o1T8I4EjNNbggDLt2JjPRLJDJGXedHOoJgao+mUKUMVnRAqkNhQWZy2BvTBOlyCqBD+ggx7h1E9uQ543",
	"QTg+VFErMZtFY6YYrUcMEYqJqJx45hE7ZIbk8D7118j8im5qPsn2iq8+GdMnsXLr5KHG/ZdsdTOzFAJF",
	"0E5H0HUv975KoTbdWYm588B+zZjubNZHX2vJMUr5GfbPYMHp9lmglaLoDnvtnKf4KnbjnC+TLRVL0fUA",
	"pPPSZzpvcI7Nwlkqn6KcrTT5NkqPymuW1v/USOt/RyWSTA7VHI8nzvjEUHAsh4FjXnBhgbkhNn8l/slh",
	"EP/5ppHRbyMgGGynvqT/SPRTkZ1xurL5KwomNz9MgzbzOUfdPThWDMCRKlNs0Kj/pjpgKgpS3YN9Lw1a",
	"fogH1n+kP85CYXA8HYeKzHjUXD7n4VEaA6VUQK+gwwCpJbEe8UCKr+m/CnQEc/ncmHsLlkhu4hNTzSi9",
	"o+ajsH/Ai9tJBsam4fPQpgVCVVEQe7NskpBAIRCx14/WOolDbTdRgQO5BzKu1dXvHEDmmPxcc7BIhlB5",
	"TAzo2F6VMS9VKCnMUr44Qrkvfh9QZqFlhV8WW4tmgLgiyhS0/lKwUT901ksoOzG51z+QWjcd9kBn4bQ9",
	"GtqFXcgX+HJV3ky6Z7VcLZd3ytvFcqZ/UkV0ZGcIDekzzkgPkj+7YX+dxCrIh7NeiXo1y35P1HCf4lFb",
	"/SCSQX86lFncKcQpVb4tWJuozMesI0ZuXpNNS1QZh7lAIqLFkG65CPyiM1XJ/XWok8VTUXBVGqRUzRfU",
	"5XfQgsQlY5nNfxFUQC/r0wwV1KD5+MU//dCe7pxfGGuVVw8Iee+5g1Lx+k8cjtDqaJcbF/P4ugQTKTj6",
	"KUtJX2zs3nZO955OL9qt027rbj+pO0OvR0aQYX3LHF1bSuZL3D5zOIr0a3ODo64RPG8idWzM1XNm0s6z",
	"0Qh5NFBKaCjVfOJN8vp2SLtJp0HYWgSxBQ+KzaxFgiYLaY42dFzpTivcVkM0UaFv81K1i4z9EDUBHpzQ",
	"MB1qE2amhHuQOGF23ZPoxkQnbcy9KpE3sSZMtiII9JFFfcSB8ZDn1TNF6CVUhoy0OyCTy2lRYkOTZZtw",
	"RSPydNst3t4cFJrvvYO/aHc24/nFEP6UV96MF+jLHxnphYiITH9aS72dp2xkdfXOkcjHm01y+wAJy5Ub",
	"w0Apgo5UwpC5JflHyLx/KKsHicgLke8RbXSnMgKVi8SUqVF7ZsF9vQ5mywitg0TCQlhlL0BTcQf8atb6",
	"CyhXt8r1ftWGW2inUe/btXq/2W9WYbPWQA24vW1X+1vlwQD+ltchWH0GieUWPDxEgMV1A6bwmIu8aVKy",
	"1It/m7k1nG+RfbAP5qvPrNHNZEAsF457SCDmK/N77CJDGn0VmXrNy4cEOoiBXy1IbA8FmPwGsI2IwGKi",
	"n07U/KUiK6AyeebqRYI2JTz0EQOWZC5V22A27xNyYHlYbs10GxeRHol5KeYDKTUjxlpQjnL9eNXZ6Ou5",
	"jeCapZj3zmafvAuO5KxyG+YgVSNk7s2FNYF/Fv39Cxb9zV6GTEMxijjdbDKL0clPoS7DbAlWXOUQoo0t",
	"yx/pl7VPo+egPqxiSeRoNfXUBI2UiSI4wB4Cjkf7fRN0E3vn8j2CnCL4pFJBuVv4f59mpLvww8zKowuf",
	"rLowt5zxk1VL8IoePet7kAx1ZSldsSOhPUZgUi+ggXvs2ZZ6G0zpPdF0zGzqxUqlODeVWrEGf/zSNPXU",
	"2UcsWuoFtvkoaEigUuYKglKPvxvvZJHA+Yu8TB5GAV3wZWGJiYT5Pm+nY8e3G4s+aZ/7kr30x1IeXPFS",
	"pPYiL7Sr85oIMY7fJN1CL9C65LvCDCFH2dH2u+aLtqbiGnXG+JoqHLllr+ZMlryZo5IKtWVv7oQEQyjS",
	"GFVJ5QW+lCcTAqSE91IHyQyd49lmMuIMQRdp/6oszVomQNwyaziVF7sgldMmg6dAJXvyNVJWzyCJk0O5",
	"ATn7nKzRLNeDFsH4vgjt2Yj9RVEJK/OClw10uWoczTtPUS375ZcfsZ84e7D1GDZloRd7pBVVKlT57voc",
	"+WQqLX3Kg0/T4jvqL1P05xOYzkMFD/ZIH00VP3XsqMx5DdHXR0g6EowyWwcYBgxZyFZGEdalAuLH0+W4",
	"Utnv01FmrHeiJNQ/rxLUxpWf1ks9cwLHFHNLP5o9lUSxObPAgplWhZoJm7o8BEM0iQsAyLNgekGtFOS0",
	"AZY6JQvy/3b3Dzvn4PLwElze7p522uBk/wHsnl60T9TnHukR/6pzvnvYsroW3d1v7Z0Omg9HQ/R2vAVt",
	"7+xhvA0PDzveMfRE8/i5+lrarZ58djuDTvh6KIK7523UI6fXzt7t9tYzvGkEd3sN/+DsuBYMEUHXJevG",
	"f3m5Gp5Prrj7tUqvvo733267/Ur7/Kw9aB86w6/Nq2qPvD0OWcdqs4PyVXXMTvoeDG339jO+g6S1x/1K",
	"82H/hfcbrdvati1u2Vnt6sG+d3auP3/Fl4O75nWPnOw+35Rro7vdC/usyx9qO6ewTbY6QeViFDQ7+7TU",
	"Qft3D5UXv31x2YIn5f7xUS0cOPV2iIb88023R8ZX9zeoffoaPp5uXZx9pReXJ+PR2dXgte9Uvu41R+Fj",
	"+UQ8l6zzo+orDMuvPm+FO0fHARqOLi6vX70embyI58njgNE7jA4mwfjRGV2NBSFnzZLT3Q9Lx3c37KHc",
	"qPr7tzfbbau/XR9aRwc3B4OzoUeGh6UeKQ9u661r2CjXj2qvz+Wh6KPa6MS6/EovL8KT3Tt+1B2Vy7eH",
	"D63JJQonn5vb1m3pYd892x7Wuncnzz2yhTqPzgSfXZTHXuXhcO/6xAq98ZDvtD6H3tCp0Jt+ndfe/MfR",
	"ZXn7kN683terz/Ckcd/9fO4+ItQjza3yV3rn9q3KSdD9/Dx4pM+c7YvH5mX/9vHzw+igeR0w+77Fno/6",
	"x8PqcXB90nq9cV/5VYvvuoeVHimfhq/Ve3i2W3aqncaldWYfl6yXZ1puWhZ73v0a4td7hhs43Dn7GjRf",
	"bkqD7tu5z+2OQ5qll8eTHsHNq9AbhNvb4Yt7XxqLal8QLJxr/vLsvp6Fzw+39cd+3R2Kg6Z7clv6+nW7",
	"Xn1xTxsn49Z166q12yNi7+Dw8f56ZPn7zsneWeWk22o++nfDfu3YPb05q5x+3Z3A+4prEa8V/W4dHY+g",
	"f/dstxujHrF86zO+Or7Y3T3bbbda9QO8v4+OtnzmHhxth3f86vTsrFp+aFiPLnl9aB60fLWH2ofj5kF7",
	"POz0yO64c3hwRY/bLd7e3X1ot8b77SNnv31Qb7XazvBq2vvz+UOrtL37EDjepNt6fDhynycnbo+UPg+2",
	"3i4Hd6P+UbW8/1IbdrYvDnbPy+T06+fd24ofjrqfX27Cbu3+lO3W/Nph6Ing5Hr/+ORU+I39vR6psMO3",
	"ry16U5kEOw+d5mlrzz5rty8mz61nTu9vm9sPt2H7c6lPntkNuq6eXl+0B5PL9vbW/U6zgS/uesRvdD/3",
	"+dXeeLtdPWWe3Tqrn+2FdPJY6WJxCB/rJ1end+LzzT6s1DF/6B62n9/o9uVD8652fDFslHvEebl3mtXz",
	"Ut+v7r91t2+atfv9vX7FGz3XO97o1em8nCCnUnn7+vDqs4fu4/FxezB6G3z2zrtb4atz1CPPr6Xj8sR7",
	"rJ7i/iHbOmy1Jhc7t/es9dgdd8/K+9bzTXO83yavw+5eOHnx78d3o/Pdr+F+5655gWoPPXKGbyuD4/Mm",
	"t7f3An7w2jj7/NUmZ+Sq+/mIPd9cnuzV/HvmtWyyf+PaD3fN58dhcO/uTXittLODLnrEHZbZKZmUn8/H",
	"QxgOSvi2eWFtfR2dDZ9Pr8+Oncbtzt3J5Di8vxdv46/k+ey8cX99sPtyUueP1D8765GB6N8cVT43Jv3r",
	"+1KrNtrtw9fr+6rYvn07f7be0LD7uI/h6fnOaenIOm53ritXB82tZnXPbnn7Bzt2jwyrzhV+6F61IDwu",
	"Hx+33o5G18Pr49NT56T6cPWAj87vJlVRO54cDDiDfmPcbd9fDNxL1Jmc7t48HvfIiAXn3mUfDfjNTmP7",
	"ZlDdPe+EztsjazfuXve6J8NH59qt3B2Oup0r0p68Da8mW/u31ZfLAN83dqSMci87Xx/ZCbVOaien3Z0S",
	"fju+urn2xPNZ6/ce+f1ycLPdI+p02T/fW3b0LCh3RRl64tzLPqR/Vj1c/ejPUnfwRz0ClKz+k+l1kfAi",
	"x4YuEaSc6gmtCHKp0HCgTK5ERomqPNQjv0aRTL9lViGayymIyszSDSttfawfPe0qBws85WuWJjCPhm5m",
	"V2eqki3bji/qIp+red4HhsKlDL8hW9kz8/nta73W0+reYzG8OKrfNrfr+zbfvSUT0a/1x6Nrxznyrrz+",
	"w1dvm1TKo50FdW4z0+Rv9RtHsfmj86TM46uSpdKOIdvHZHXEN1dBBZJOWdbx2pnLH5CBDPqTxFs6GdVx",
	"o2KIdrYkIh3dpfIhqckrsSEDFbTFN0bGh3y4Li6y7UpMdLL2plTJ3GNJv8O8x2WNMmMaQtKpoIWKhZiw",
	"N+gsmy9zSyzwt8wHRDNqh3HG0NKiozOFvX7QdTMHZjH2sxOdd7mGgj6Zithw5iW25bJydhW+ZLxIo5/f",
	"CCjfAGqqhNsMspbAI10uyUjdVE4XRxZDoqBfP4uP8vi1sQze7UOOnjIdI/N+kTXUg+gWLgVuUaEXyhxI",
	"Eh6vZJBZvVyr1rMvoa3VZ2d87zHwoBNlbzPX0vUE9L1hooJPlHANPU5N5UgjoDjomBnNnP6L5pQuaZR8",
	"qmC6rEW5VxOEXUnXmeMkRbf8LE+kcEgscGJxsg6hm0T5vw3CeaJuKwJ6iAg0VkuCb4gIQNQopWeVi4Qy",
	"4Ragjxi2YDGg1CsSEUg9N5fPVZZ93kgxS5ZAXHypF7XKRweGOkRub9opzeC2W9qHks/IemGd8xcbZLL2",
	"23SzKUMr+3Rrm3WZK/Cwcoy3kKHNuix4RWJVt4zIv1Vd5sKmVnVYdP/0/Vu25IlsD/0E0Hw+lSpkgDng",
	"Lg09GzCkYhT6qpbsxQD0QwHmF0mnp6lQM6HyYTLWXgcGAh9BYsKhoOeBjIZAcx7vEciQFnzatpgbF8Zt",
	"jZQcYaouhrVvXiLcIyz0kK4sy9CAMpQHYwRcOIpLZyhuBipdR86ujwAcw6hiGBYAc/JJ9EhAOccmTtHH",
	"ryoax4fCcvUlgVkPIKijLCIplOO9s+gOK5F2t8l7jzOpG2tvqTV7zKZub7Ch1uyR/fLI2ntjzfYLbhJV",
	"EbXNc23ibJ118lJN8p9OTF30HJK5bo6Y4NsMu2yYXcNCQhal0KRyEee4cOMJvTNtNPvWfQbkt4UH0eJU",
	"oCKvxTk4UcZPMm2GWrhoBIYugSIJGHpB0SQOm9Lo2STc/Anlae39d71JPKdN/3wx+H0vBq9hfawXNaOU",
	"aitkWEy6ktX1su8iyDSv9NW/DqLhju9vpAqsWkrVXLeLoUrLJvf9uzJVBjQrvlzXdhHUOP9UFL2OkdK5",
	"p7yoErwsZF771YuYawXQchGoqrwYpf7HTuLxeFyE6rPyzJq+vHTaae+fd/cL1WK56Arf0yqoUIxw0d1V",
	"w5ssSAZUESMAA5wImvmSq0ZPB8gPX3K1YrlYyemakopMJcujBPHSH9j+rnZLVpmtQ6SDUrTMVAW3gBF0",
	"km9UpCQS0XtP+i00GL+NaFQZ/VpowllJmUo9mGYHq0oZmBKgRCyydTpqXP+3Y2tUku8Oq9hr6COhDIe/",
	"Z7x8GuX4R8gLChxV6AsTxXvCjWKNvkSv0EUcp004LT7/lOeBv8nR9LPQajGq5XIi+N0krXnmEr/0bMon",
	"TxFaergnqKTYOU2ZJE0ki9Q/cGiTizs/aIdoFTJKVsG2Hrry5w/dClW51CFS/nCsEdGj1/780W/J1KUt",
	"OTBATPIGiHlbY1L/Z2AyJHRMZpag8c9Y/VuCXgMdYq3yuwG11IMudkqEq10cCe+/f5N7hIe+D9nEZLcn",
	"hZASXjE/KTil6A9V6DTrUby2rvADAUHjqGseBFROHUex4NxUE1Se4BFiMBLuSt4bg029CquvLjBLmm98",
	"XnBdUi6ix+G1kEFcRM/Mf8yOTz+Q/D19fEph9n1O3lQ+evSOnbX05qMqaaHUD2T/y4QOm75a/FPy/JQ8",
	"a0oeIzSyJM1HKU8b6EsRDVcoSqnXlddSlWLA/2XKUopSGRyUpstPhemn2PqLKkwL5Zc2BJNaU4b+IptM",
	"lZg15ElCWP0bSZE/QfdKUEYB/mdrX4nxr80gWSylSo+h8bRGal9V6DKvWmfLNYFeRUn5cdL4zJJ2belV",
	"/6gBsvbm99SpLcmSqg6+ZAN4pi7Hj5ziA0wwdxOHOFh6hmMxPbp1HQZ1weIjAQEmmocxJQD2aShM6D4P",
	"PbHsmFdlRX4e8isPeUWnBVtDskBcxF3fzcUGIiaAUP3WoxV6kJnSbeBX4dLQcc3t2HH34vy34n/cRjpU",
	"Fcqd6Noy4vKsbRS9Mr96L8Ut19hO10iEjHCVWxS/Yy+RUTa4EWfR4/VKvpsilnFji6qNFZd3MssXFfGE",
	"AiTdsaYmo47UhSR6o74QgSs2lmzFs5gEP/fjyv04JdaCTZla7rmN+Z+519LbY41Nl0gYXr7n4nImcsvN",
	"7TP9fgJ6hZZIHURMbT9kAxvpamk0tddi17+qfrtsZ0R4/twYqzdGRKtF+yJayk32xU8j9aeR+u9mpM7J",
	"ptXyjvepv1jBiJQFCHQkVLoKLl+hN/TITHPI4jaqYO60Zu9Cl9vuxdmGh7/ESYdPaTEHIhj/Ja43NdsF",
	"kk59/G87/qeTnt0Kap8luX+ODacP4s7xYNZaTJuUVFnFRSFdiXaq7uKfyhjTOWQJ/vhpOEOMnyfOv+bE",
	"0TL/r3feTN8WhJ4H4qjSiJum22z15Q4kcdGxyOWpMZtWL+tPgBKs2Rt1fVcqMs3fdSbU/skSfuFSqg8g",
	"+dvPXfxzF2+yi9E8B8mdG8e7LT4hL0yTd/L9bCji3EQNKkoWSCVSgogef/4LquhLp/M9Tm/KkmJn5s04",
	"lQmoHjqMi2mnoyFhgIuqwp2LBzqvDAa4pIv2KyccYoXowcrSqKq0lZkYTQEdTJxlA3ABHfTOYSz9mIZ5",
	"0y4eZhWcb9//fwAAAP//X2XfXSXLAAA=",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
